#pragma once

#include "ap_fixed.h"

/// <summary>
/// マップサイズ
/// </summary>
#define MAP_SIZE 60

/// <summary>
/// 学習回数
/// </summary>
#define LEARNING_TIME 20000

/// <summary>
/// ハードウェア関数内で実行される回数
/// </summary>
#define HW_TIME 2000

/// <summary>
/// 生成されるベクトルの次元
/// </summary>
#define VECT_DIM 54

/// <summary>
/// ベクトル距離計算で扱える最大の次元（2のべき乗）
/// </summary>
#define LIMIT_DIM 64

/// <summary>
/// t = 0のときの近傍範囲
/// </summary>
#define SCOPE 18.0

/// <summary>
/// 近傍学習で使うアルファ値
/// </summary>
#define ALPHA 0.5

/// <summary>
/// 並列度
/// </summary>
#define PARALLEL_LEVEL 4

#define NEURON_NUM (MAP_SIZE / PARALLEL_LEVEL)

/// <summary>
/// 陽性データ (問題あり) のパス
/// </summary>
#define POSITIVE_PATH "/mnt/SOMData/pca_All_D.csv"

/// <summary>
/// 陰性データ (問題なし) のパス
/// </summary>
#define NEGATIVE_PATH "/mnt/SOMData/pca_All_H.csv"

/// <summary>
/// 任意精度固定少数点型
/// </summary>
typedef ap_fixed<16, 2> fixed16_2;
// 乗算時に使用
typedef ap_fixed<32, 4> fixed32_4;
// 距離計算に使用
typedef ap_ufixed<16, 2, AP_TRN_ZERO, AP_SAT> ufixed16_2;
// 近傍範囲計算に使用
typedef ap_uint<16> uint_16;